package com.relovate.tripVerticles.main;

import java.net.Inet4Address;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.util.Enumeration;

import com.relovate.tripVerticles.verticles.RequestListnerVert;
import com.relovate.tripVerticles.verticles.TcsLisnerVerticle;

import io.vertx.core.Vertx;
import io.vertx.core.VertxOptions;
import io.vertx.core.eventbus.DeliveryOptions;
import io.vertx.core.eventbus.EventBus;
import io.vertx.core.eventbus.EventBusOptions;
import io.vertx.core.eventbus.Message;
import io.vertx.core.eventbus.MessageConsumer;
import io.vertx.core.json.JsonObject;
import io.vertx.core.net.NetServerOptions;
import io.vertx.core.spi.cluster.ClusterManager;
import io.vertx.ext.bridge.BridgeOptions;
import io.vertx.ext.bridge.PermittedOptions;
import io.vertx.ext.eventbus.bridge.tcp.TcpEventBusBridge;
import io.vertx.spi.cluster.hazelcast.HazelcastClusterManager;

public class VertxCreator {
	private static Vertx vertx;
	private static String deploymentId;

public static void main(String args[])
{
	VertxCreator vertxCreator=new VertxCreator();
	 EventBusOptions eventBusOption = new EventBusOptions();
	 eventBusOption.setClustered(true);
  
	    ClusterManager mgr = new HazelcastClusterManager();
	    VertxOptions options = new VertxOptions().setClusterManager(mgr).setMaxWorkerExecuteTime(300000000000L).setMaxEventLoopExecuteTime(120000).setClusterHost(getCurrentIp());	  
	Vertx.clusteredVertx(options, culRes -> {
	  if (culRes.succeeded()) {		
			 vertx = culRes.result();				 
			 vertxCreator.deployMainVerticle();
				} else {
	    System.out.println("Failed to create vertx instance");
	  }
	});
	
}
private void run()
{
	
EventBus eb=vertx.eventBus();
	
	MessageConsumer<JsonObject> consumer=eb.consumer("requestContent",(Message<JsonObject> msg) ->
	{
		String tripRequest=msg.body().getString("tripReq");
		DeliveryOptions deploymentOpt=new DeliveryOptions();
		deploymentOpt.setSendTimeout(120000);
		System.out.println("Get request from service");		
		eb.send("tripReq", tripRequest,deploymentOpt,asynResult -> {
			if (asynResult.succeeded()) {
				//System.out.println("vertxCreator reply to client "+asynResult.result().body().toString().substring(0, 100));
				DeliveryOptions deliveryOption=new DeliveryOptions();
				deliveryOption.setSendTimeout(120000);
				msg.reply(new JsonObject().put("reponse", asynResult.result().body().toString()),deliveryOption);
				System.out.println("reply  message send "+msg.isSend()+", to address"+msg.replyAddress());

			}else
			{
				System.out.println("consumer send event bus failed"+asynResult.cause().getMessage());
				asynResult.cause().printStackTrace();
				//TODO undelopy verticle
				JsonObject exceptionMsgObj=new JsonObject();
				exceptionMsgObj.put("errorCode", "RLVEF01");
				DeliveryOptions deliveryOption=new DeliveryOptions();
				deliveryOption.setSendTimeout(120000);
				msg.reply(new JsonObject().put("reponse", exceptionMsgObj.toString()),deliveryOption);				
			}
		}
	  );
	});
	consumer.completionHandler(res -> {
		if (res.succeeded()) {
			System.out.println("The requestContent consumer handler registration has reached all nodes");
		} else {
			System.out.println("requestContent consumer Registration failed!");
		}
	});
		/*consumer.handler(message -> {
			System.out.println(message.body());
		});*/	
	TcpEventBusBridge bridge = TcpEventBusBridge.create(
		    vertx,
		    new BridgeOptions().addInboundPermitted(new PermittedOptions().setAddress("vrctDepReq"))
		        .addInboundPermitted(new PermittedOptions().setAddress("requestContent"))
		        .addInboundPermitted(new PermittedOptions().setAddress("unDeploy"))
		        .addOutboundPermitted(new PermittedOptions().setAddress("out")),new NetServerOptions().setIdleTimeout(0));

		bridge.listen(7000, res -> {
		  if (res.succeeded()) {
			  System.out.println("TCP Bridge listening on 7000: "+res.result().toString());
			  } else {
		      System.out.println("Bridge listener failed "+res.cause().toString());
		  }
		});
}
public void deployMainVerticle()
{
	String verticleID=RequestListnerVert.class.getName();	
	vertx.deployVerticle(verticleID,res -> {
		if (res.succeeded()) {
		    // here is your ID
			deploymentId=res.result();
			System.out.println("RequestListnerVert deploy successfull");			
		  } else {
		    System.out.println("RequestListnerVert deploy failed!");
		  }
		
			});
	verticleID=TcsLisnerVerticle.class.getName();	
	vertx.deployVerticle(verticleID,res -> {
		if (res.succeeded()) {
		    // here is your ID
			deploymentId=res.result();
			System.out.println("TcsListnerVerticle deploy successfull");			
		  } else {
		    System.out.println("TcsListnerVerticle deploy failed!");
		  }
		
			});
}
/*public void testSendMessageWithReplyBacktrack() {
    // Send a request and get a response
    NetClient client = vertx.createNetClient();    

    client.connect(7000, "localhost", conn -> {
      

      NetSocket socket = conn.result();

      final FrameParser parser = new FrameParser(parse -> {
        System.out.println(parse.succeeded());
        JsonObject frame = parse.result();
        System.out.println(frame.getString("type"));
        System.out.println(frame.getBoolean("send"));
        System.out.println(frame.getJsonObject("body").getString("reponse"));
        client.close();        
      });

      socket.handler(parser);

      FrameHelper.sendFrame("send", "unDeploy", "#backtrack", new JsonObject(), socket);
    });
  }*/
public static String getCurrentIp() {
    try {
        Enumeration<NetworkInterface> networkInterfaces = NetworkInterface
                .getNetworkInterfaces();
        while (networkInterfaces.hasMoreElements()) {
            NetworkInterface ni = (NetworkInterface) networkInterfaces
                    .nextElement();
            Enumeration<InetAddress> nias = ni.getInetAddresses();
            while(nias.hasMoreElements()) {
                InetAddress ia= (InetAddress) nias.nextElement();
                if (!ia.isLinkLocalAddress() 
                 && !ia.isLoopbackAddress()
                 && ia instanceof Inet4Address) {
                    return ia.getHostAddress();
                }
            }
        }
    } catch (SocketException e) {
        System.out.println("unable to get current IP ");
        e.printStackTrace();
    }
    return null;
}
}
