package com.relovate.tripVerticles.verticles;

import io.vertx.core.AbstractVerticle;
import io.vertx.core.eventbus.DeliveryOptions;
import io.vertx.core.eventbus.EventBus;
import io.vertx.core.eventbus.Message;
import io.vertx.core.eventbus.MessageConsumer;
import io.vertx.core.json.JsonObject;
import io.vertx.core.net.NetServerOptions;
import io.vertx.ext.bridge.BridgeOptions;
import io.vertx.ext.bridge.PermittedOptions;
import io.vertx.ext.eventbus.bridge.tcp.TcpEventBusBridge;

public class TcsLisnerVerticle extends AbstractVerticle {
		
	@Override
	public void start() throws Exception {
		
		EventBus eb=vertx.eventBus();
			
		
			MessageConsumer<JsonObject> consumer=eb.consumer("requestContent",(Message<JsonObject> msg) ->
			{
				String tripRequest=msg.body().getString("tripReq");
				DeliveryOptions deploymentOpt=new DeliveryOptions();
				deploymentOpt.setSendTimeout(120000);
				System.out.println("Get request from service");		
				eb.send("tripReq", tripRequest,deploymentOpt,asynResult -> {
					if (asynResult.succeeded()) {						
						DeliveryOptions deliveryOption=new DeliveryOptions();
						deliveryOption.setSendTimeout(120000);
						msg.reply(new JsonObject().put("reponse", asynResult.result().body().toString()),deliveryOption);
						System.out.println("reply  message send "+msg.isSend()+", to address"+msg.replyAddress());

					}else
					{
						System.out.println("consumer send event bus failed"+asynResult.cause().getMessage());
						asynResult.cause().printStackTrace();
						//TODO undelopy verticle
						JsonObject exceptionMsgObj=new JsonObject();					
						exceptionMsgObj.put("errorCode", "RLVEF01");
						DeliveryOptions deliveryOption=new DeliveryOptions();
						deliveryOption.setSendTimeout(120000);
						msg.reply(new JsonObject().put("reponse", exceptionMsgObj.toString()),deliveryOption);				
					}
				}
			  );
			});
			consumer.completionHandler(res -> {
				if (res.succeeded()) {
					System.out.println("The requestContent consumer handler registration has reached all nodes");
				} else {
					System.out.println("requestContent consumer Registration failed!");
				}
			});
				/*consumer.handler(message -> {
					System.out.println(message.body());
				});*/	
			TcpEventBusBridge bridge = TcpEventBusBridge.create(
				    vertx,
				    new BridgeOptions().addInboundPermitted(new PermittedOptions().setAddress("vrctDepReq"))
				        .addInboundPermitted(new PermittedOptions().setAddress("requestContent"))
				        .addInboundPermitted(new PermittedOptions().setAddress("unDeploy"))
				        .addOutboundPermitted(new PermittedOptions().setAddress("out")),new NetServerOptions().setIdleTimeout(0));

				bridge.listen(7000, res -> {
				  if (res.succeeded()) {
					  System.out.println("TCP Bridge listening on 7000: "+res.result().toString());
					  } else {
				      System.out.println("Bridge listener failed "+res.cause().toString());
				  }
				});
}

	@Override
	public void stop() throws Exception {
		System.out.println("TcsLisnerVerticle stopped");
	}
}